de.caff.util

## Class ImprovedStringWriter

- java.lang.Object
- - java.io.Writer
  - - de.caff.util.ImprovedStringWriter

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.Appendable, java.lang.AutoCloseable

      public class ImprovedStringWriter
      extends java.io.Writer

  Basically the same as `StringWriter`, but using a more efficient `StringBuilder` instead of a `StringBuffer`.

  This means that this class is not thread-safe, but in most usage scenarios this is not necessary.

  Author:
    Rammi

- - ### Field Summary

    - ### Fields inherited from class java.io.Writer

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImprovedStringWriter()` Constructor.
    `ImprovedStringWriter(int initialCapacity)` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.io.Writer` | `append(char c)` Appends the specified character to this writer.
    `java.io.Writer` | `append(java.lang.CharSequence csq)` Appends the specified character sequence to this writer.
    `java.io.Writer` | `append(java.lang.CharSequence csq, int start, int end)` Appends a subsequence of the specified character sequence to this writer.
    `void` | `close()` Closes the stream, flushing it first.
    `void` | `flush()` Flushes the stream.
    `java.lang.StringBuilder` | `getBuffer()` Get the underlying buffer.
    `java.lang.String` | `toString()` Returns the current content of this writer.
    `void` | `write(char[] cbuf, int off, int len)` Writes a portion of an array of characters.
    `void` | `write(int c)` Writes a single character.
    `void` | `write(java.lang.String str)` Writes a string.
    `void` | `write(java.lang.String str, int off, int len)` Writes a portion of a string.

    - ### Methods inherited from class java.io.Writer

      `write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ImprovedStringWriter

          public ImprovedStringWriter()

      Constructor.

    - #### ImprovedStringWriter

          public ImprovedStringWriter(int initialCapacity)

      Constructor.
      Parameters:
        `initialCapacity` - initial buffer capacity
      Throws:
        `java.lang.IllegalArgumentException` - if `initialCapacity` is negative

  - ### Method Detail

    - #### write

          public void write(int c)
                     throws java.io.IOException

      Writes a single character. The character to be written is contained in the 16 low-order bits of the given integer value; the 16 high-order bits are ignored.

      Subclasses that intend to support efficient single-character output should override this method.

      Overrides:
        `write` in class `java.io.Writer`
      Parameters:
        `c` - int specifying a character to be written
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### write

          public void write(@NotNull
                            char[] cbuf,
                            int off,
                            int len)
                     throws java.io.IOException

      Writes a portion of an array of characters.
      Specified by:
        `write` in class `java.io.Writer`
      Parameters:
        `cbuf` - Array of characters
        `off` - Offset from which to start writing characters
        `len` - Number of characters to write
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### write

          public void write(@NotNull
                            java.lang.String str)
                     throws java.io.IOException

      Writes a string.
      Overrides:
        `write` in class `java.io.Writer`
      Parameters:
        `str` - String to be written
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### write

          public void write(@NotNull
                            java.lang.String str,
                            int off,
                            int len)
                     throws java.io.IOException

      Writes a portion of a string.
      Overrides:
        `write` in class `java.io.Writer`
      Parameters:
        `str` - A String
        `off` - Offset from which to start writing characters
        `len` - Number of characters to write
      Throws:
        `java.lang.IndexOutOfBoundsException` - If `off` is negative, or `len` is negative, or `off+len` is negative or greater than the length of the given string
        `java.io.IOException` - If an I/O error occurs

    - #### append

          public java.io.Writer append(java.lang.CharSequence csq)
                                throws java.io.IOException

      Appends the specified character sequence to this writer.

      An invocation of this method of the form `out.append(csq)` behaves in exactly the same way as the invocation

               out.write(csq.toString())

      Depending on the specification of `toString` for the character sequence `csq`, the entire sequence may not be appended. For instance, invoking the `toString` method of a character buffer will return a subsequence whose content depends upon the buffer's position and limit.

      Specified by:
        `append` in interface `java.lang.Appendable`
      Overrides:
        `append` in class `java.io.Writer`
      Parameters:
        `csq` - The character sequence to append. If `csq` is `null`, then the four characters `"null"` are appended to this writer.
      Returns:
        This writer
      Throws:
        `java.io.IOException` - If an I/O error occurs
      Since:
        1.5

    - #### append

          public java.io.Writer append(java.lang.CharSequence csq,
                                       int start,
                                       int end)
                                throws java.io.IOException

      Appends a subsequence of the specified character sequence to this writer. `Appendable`.

      An invocation of this method of the form `out.append(csq, start, end)` when `csq` is not `null` behaves in exactly the same way as the invocation

               out.write(csq.subSequence(start, end).toString())

      Specified by:
        `append` in interface `java.lang.Appendable`
      Overrides:
        `append` in class `java.io.Writer`
      Parameters:
        `csq` - The character sequence from which a subsequence will be appended. If `csq` is `null`, then characters will be appended as if `csq` contained the four characters `"null"`.
        `start` - The index of the first character in the subsequence
        `end` - The index of the character following the last character in the subsequence
      Returns:
        This writer
      Throws:
        `java.lang.IndexOutOfBoundsException` - If `start` or `end` are negative, `start` is greater than `end`, or `end` is greater than `csq.length()`
        `java.io.IOException` - If an I/O error occurs
      Since:
        1.5

    - #### append

          public java.io.Writer append(char c)
                                throws java.io.IOException

      Appends the specified character to this writer.

      An invocation of this method of the form `out.append(c)` behaves in exactly the same way as the invocation

               out.write(c)

      Specified by:
        `append` in interface `java.lang.Appendable`
      Overrides:
        `append` in class `java.io.Writer`
      Parameters:
        `c` - The 16-bit character to append
      Returns:
        This writer
      Throws:
        `java.io.IOException` - If an I/O error occurs
      Since:
        1.5

    - #### flush

          public void flush()
                     throws java.io.IOException

      Flushes the stream. If the stream has saved any characters from the various write() methods in a buffer, write them immediately to their intended destination. Then, if that destination is another character or byte stream, flush it. Thus one flush() invocation will flush all the buffers in a chain of Writers and OutputStreams.

      If the intended destination of this stream is an abstraction provided by the underlying operating system, for example a file, then flushing the stream guarantees only that bytes previously written to the stream are passed to the operating system for writing; it does not guarantee that they are actually written to a physical device such as a disk drive.

      Specified by:
        `flush` in interface `java.io.Flushable`
      Specified by:
        `flush` in class `java.io.Writer`
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### close

          public void close()
                     throws java.io.IOException

      Closes the stream, flushing it first. Once the stream has been closed, further write() or flush() invocations will cause an IOException to be thrown. Closing a previously closed stream has no effect.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in class `java.io.Writer`
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### getBuffer

          public java.lang.StringBuilder getBuffer()

      Get the underlying buffer.
      Returns:
        the underlying buffer holding the content of this writer
      See Also:
        `toString()`

    - #### toString

          public java.lang.String toString()

      Returns the current content of this writer.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        buffer content
      See Also:
        `getBuffer()`